title	"CapsCtrl - interchange CapsLock and Ctrl keys"

bseg	segment	at 40h		;BIOS RAM segment
	org	96h
kbdflg3	db	?		;Keyboard status byte for enhanced keyboards
bseg	ends

cseg	segment
	assume	cs:cseg, ds:cseg
.186
	org	50h		;Convenient place in PSP for some variables
pint15	dd	?		;Previous int-15 interrupt vector
	org	100h		;.com file

start:	mov	ax,3515h	;Save previous int-15h vector
	int	21h
	mov	word ptr pint15,bx
	mov	word ptr pint15+2,es	
	mov	dx,offset int15
	mov	ah,25h		;Take over keyboard interrupt
	int	21h
	mov	dx,offset csegend + 15	;Round up to next paragraph
	shr	dx,4		;Convert from bytes to paragraphs
	mov	ax,3100h
	int	21h		;Terminate and Stay Resident


;int-15h interrupt routine

int15:	jnc	short int159	;Processing suppressed
	pushf			;Save CF
	cmp	ah,4fh		;Int-15h keyboard intercept?
	jnz	short int158	;No, go chain to previous handler
	mov	ah,al		;Set ah = keycode bit 7 and kill
	and	ax,807fh	; bit 7 in al for compares
	cmp	al,1dh		;Ctrl (make or break)?
	jz	short int152	;Yes
	cmp	al,3ah		;CapsLock (make or break)?
	jnz	short int157	;No, go chain to previous handler
	mov	al,1dh		;Switch to left Ctrl (it's the left,
	jmp	short int157	; since 0e0h can't be previous byte)

int152:	push	ds		;Left or right Ctrl key
	push	bseg		;Check BIOS RAM flag to see which one
	pop	ds
	assume	ds:bseg
	test	kbdflg3,2	;Last byte received = 0e0h?
	pop	ds
	jnz	short int157	;Yes: right Ctrl, so don't touch it
	mov	al,3ah		;Switch to CapsLock

int157:	or	al,ah		;Restore make/break bit
	mov	ah,4fh		;Restore ah
int158:	popf			;Restore flags
int159:	jmp	[pint15]	;Chain to previous interrupt

csegend	equ	$

cseg	ends

	end	start
