title	EXEC.ASM - MS-DOS FILE LOADING & EXECUTION EXAMPLE
.186

prefix	segment at 0	;Partial Program Segment Prefix (PSP) template
	org	2ch
envseg	dw	?
	org	80h
cmdcnt	db	?
prefix	ends

;Parameter block. Pointed to by es:bx before a program is loaded

dseg	segment public 'data'
pblock	dw	?	;Segment address of environment
	dw	80h
	dw	?	;Segment of pointer to command line
	dw	5Ch
	dw	?	;Segment of pointer to default FCB
	dw	6Ch
	dw	?	;Segment of pointer to 2nd default FCB
spsave	dw	?	;Storage area for SS:SP
sssave	dw	?
filnam	db	"myprog.exe",0			;Name of file to be run
errmsg	db	"File not found",0DH,0AH,'$'
msg1	db	"Program starting",0DH,0AH,'$'
msg2	db	0DH,0AH,"Program completed$"
dseg	ends

sseg	segment stack 'data'
	dw	80h dup (?)
sseg	ends

cseg	segment public 'code'
	assume	cs:cseg, ds:prefix

setup:	push	ds		;Display "program starting" message
	mov	ax,dseg
	mov	ds,ax
	mov	dx,offset msg1
	mov	ah,9
	int	21h
	pop	ds

	mov	bx,offset eop+10h	;Get paragraph # of end of program
	shr	bx,4		;Note: cseg must be loaded after dseg
	add	bx,cseg		; and sseg for this to work
	mov	ax,ds  		;Get paragraph # of program start
	sub	bx,ax  		;Difference is total program length
	mov	ah,4ah 		;Shrink allocated memory to bx paragraphs
	int	21h		; (program size)

	mov	ax,dseg		;Point es at local data area
	mov	es,ax
	assume	es:dseg
	mov	bx,offset pblock	;Point es:bx at parameter block
	mov	di,bx		;Fill in parameter block
	mov	ax,envseg	;Get segment address of environment
	stosw			;With environment segment
	mov	ax,ds  		;Get program prefix segment address
	mov	cx,3
filblk:	inc	di		;Bypass offset
	inc	di		;Store command line & FCB ptr segment
	stosw
	loop	filblk

	push	es
	pop	ds
	assume	ds:dseg
	mov	dx,offset filnam ;*ds:dx = file name of program to run
	mov	spsave,sp	;Save stack location
	mov	sssave,ss	;(note that es override is implied)
	mov	ax,4b00h	;Load and execute new program
	int	21h		;All regs may change except cs

	mov	ax,dseg		;Point ds at local data area
	mov	ds,ax
	mov	ss,sssave	;Restore original stack
	mov	sp,spsave
	mov	ax,4c00h	;Default no-error termination code
	mov	dx,offset msg2	;Default "program completed" message
	jnc	short quit	;Leave clean if CF not set on return
	mov	dx,offset errmsg	;If CF set, print an error message
	inc	ax		;Change to error code (1)
quit:	push	ax		;Save termination code
	mov	ah,9		;Display termination message
	int	21h
	pop	ax
	int	21h		;Bye

eop	db	"end of program"

cseg	ends

	end	setup
