;GETCPU - return al = x for CPU = 80x86.  _ax, _cx, _di changed.
;Pentium cpuid changes ebx and edx as well.

cpuid	macro			;Generate Pentium cpuid instruction
	db	0fh,0a2h
	endm

getcpu:	mov	_di,_sp		;Determine machine type. Save _sp
	mov	_ax,_sp		;ax = nonzero
	and	sp,not 3	;Be sure stack is on dword boundary for 486
	mov	cl,20h
	shr	_ax,cl		;80186, 80286 shift modulo 20h, i.e., here nop
	jz	short getcp5	;8086 shifts 32 positions clearing ax register
	push	_sp		;80286 and higher push sp value before push
	pop	_ax
	test	al,2		;8086, 80186 would have decremented value
	mov	al,1		;At least 80186
	jnz	short getcp5
	inc	_ax		;At least 80286
	sgdt	fword ptr gdtadr
	cmp	byte ptr gdtadr+5,0ffh	;80286?
	jz	short getcp5
	pushfd			;Save flags twice: First to restore them
	pushfd			;Second to get them
	pop	eax
	or	eax,240000h	;Set ID & Alignment Check (AC) bits in eflags
	push	eax
	popfd			;Tell CPU about it
	pushfd			;See if CPU took the bait
	pop	eax
	shr	eax,10h		;ax = flags high word
	and	al,24h		;Isolate IC and AC flags
	jz	short getcp3	;Can't set either: must be 386
	cmp	al,4		;Can't set ID bit?
	jz	short getcp4	;No, must be 486
	xor	eax,eax		;586 or higher
	inc	_ax		;eax = 1
	cpuid			;Get CPU ID
	mov	al,ah		;Forget about model and stepping numbers...
	and	al,0fh		;Isolate ID. 5 for Pentium
	jmp	short getcp4
getcp3:	mov	al,3		;386
getcp4:	popfd			;Restore flags

getcp5:	mov	_sp,_di		;Restore sp in case and sp,not 3 changed it
	cbw			;_ax = cputyp
	return
