title	GTVTD - program to get and display VTD tick count

VTD_Device_ID			equ	5
VTD_API_GET_TIME_IN_CLOCK_TICKS equ	100h	; time in clock ticks
VTD_API_GET_TIME_IN_MS		equ	101h	; time in milliseconds

public	gtvtd
public	pbyte, print, printe, printq, printr, printw
public	start

dseg	segment
VTD	dd	?
winvno	dw	?
failmsg	db	"You need to run under Enhanced-Mode Windows$"
msg	db	"The VTD 1193182-Hz tick count = $"
dseg	ends

sseg	segment	stack
	dw	100 dup(?)
sseg	ends

cseg	segment
	assume	cs:cseg, ds:dseg

.386p
start:	mov	ax,dseg
	mov	ds,ax
	call	gtvtd		;Get VTD entry address
	mov	dx,offset failmsg
	jz	short start8	;No go
	mov	ah,9
	mov	dx,offset msg
	int	21h
	mov	ax,VTD_API_GET_TIME_IN_CLOCK_TICKS
	call	[VTD]
	call	printq		;Print edx eax
	jmp	short start9

start8:	mov	ah,9		;Display message *dx
	int	21h
start9:	mov	ax,4c00h	;Quit
	int	21h


comment |GTVTD - get VTD address for Windows Enhanced mode operation.
ax changed.
|

gtvtd:	smsw	ax		;Running in protected mode?
	test	al,1
	jz	short gtvt9	;No
	mov	ax,1600h	;Get Enhanced-Mode Windows Installed State
	int	2fh		;multiplex interrupt
	test	al,7fh
	jz	short gtvt9	;386 enhanced-mode Windows not running
	mov     winvno,ax
	push	es		;Need to call for both real and protect modes
	push	bx		; (they differ)
	push	di
	mov	ax,1684h	;Get VxD address
	mov	bx,VTD_Device_ID
	int	2fh
	mov	word ptr VTD,di
	mov	word ptr VTD+2,es
	pop	di
	pop	bx
	pop	es
	or	sp,sp		;RNZ to signal success
gtvt9:	ret


;Print routines from printw.asm plus new printq and printd functions

printq:	call	printr	;Print edxeax

printr:	xchg	eax,edx

printd:	call	printe	;Print eax

printe:	ror	eax,16
	mov	bx,ax

printw:	mov	al,bh	;Get high order byte
	call	pbyte	;Print both nibbles
	mov	al,bl	;Then print low order byte

pbyte:	push	ax	;Save a copy of al
	shr	al,4
	call	print	;Print hex digit
	pop	ax	;Restore original al
			;Fall thru to print 2nd
print:	and	al,0fh	;Mask off high nibble
	add	al,90h	;Add 90H using BCD arithmetic
	daa
	adc	al,40h	;Then 40H plus CY
	daa
	push	dx
	xchg	dx,ax	;Display with DOS character
	mov	ah,2	; display entry
	int	21h
	pop	dx
	ret

cseg	ends

	end	start
