title VSSTD - Example VxD
.386p

include VMM.Inc					;Include file given in DDK
include Debug.Inc				;Include file given in DDK

VSSTD_ID	equ	28c2h
VERSION	equ	1

Declare_Virtual_Device VSSTD, VERSION, 0, VSSTD_Control, \
    VSSTD_ID, Undefined_Init_Order, VSSTD_API_Handler, \
    VSSTD_API_Handler,

VxD_IDATA_SEG					;Initialization data goes here
VxD_IDATA_ENDS					;It's discarded after init

VxD_DATA_SEG
VSSTD_API_Table label dword			; API jump table
	dd	offset32 Get_Version		;ax = 0
	dd	offset32 Special_Register	;ax = 1
	dd	offset32 Get_Handle		;ax = 2
VSSTD_Max_API equ	($ - VSSTD_API_Table)/4
VMActive dd	0				;VMhandle of last caller
gdt	dw	3 dup(?)
VxD_DATA_ENDS

VxD_LOCKED_DATA_SEG				;Pagelocked data here - try to
VxD_LOCKED_DATA_ENDS				; keep this to a minimum.

VxD_ICODE_SEG 					;Initialization Code Segment
BeginProc VSSTD_Device_Init			;Discarded after init
	clc					;No error: load VxD
	ret
EndProc VSSTD_Device_Init
VxD_ICODE_ENDS

;VSSTD_API_Handler - exported API procedure callable from any VM
;     Execute INT 2Fh with AX=1684h and BX=device ID to get call-back
;     address (see GTVSSTD routine below).  When this address is called,
;     control comes here
;
;  On Entry: ebx = VM Handle, ebp = Client register structure.
;	Client_CS:IP = instruction following API call.
; 	Client_AX = function number.
;  On Exit: Client CF = 0: success; = 1: hosed

VxD_CODE_SEG					;Protect-Mode Code Segment
VSSTD_API_Handler:
	movzx   eax, [ebp.Client_AX]		;eax = function #
	cmp	ax, VSSTD_Max_API		;Is it valid?
	jae	short fail			;Nope
	and	[ebp.Client_EFlags],NOT CF_Mask	;RNC
	jmp	VSSTD_API_Table[4*eax]		;Dispatch
fail:	mov	[ebp.Client_AX],0		;FALSE return value
	or	[ebp.Client_EFlags], CF_Mask	;RC
	ret

Get_Version:					;VSSTD API entry ax = 0
	mov	[ebp.Client_AX], VERSION
	ret

Special_Register:				;VSSTD API entry ax = 1
	mov	eax,cr3				;Page-directory phys addr
	mov	[ebp.Client_EAX],eax		;Return value in Client eax
	ret

Get_Handle:					;VSSTD API entry ax = 2
	push	ebx				;Save handle to current VM
	and	[ebp.Client_Flags], NOT CF_Mask ;Default success
	movzx	eax, [ebp.Client_BX]		;Get requested VMID
	or	eax, eax			;Non-zero?
	jz	short gthnd4			;0, ebx has current handle

gthnd2:	cmp	eax, [ebx.CB_VMID]		;Found it?
	je	short gthnd4			;Yes
	VMMCall Get_Next_VM_Handle		;Get next
	VMMCall Test_Cur_VM_Handle		;Back to start of list?
	jne	gthnd2				;No
	Trace_Out "VSSTD_API: Handle for VM #AL not found"
	or	[ebp.Client_Flags], CF_Mask	;Signal error

gthnd4:	xchg	ecx,eax				;Get LDT selector for VM
	sldt	ax				;ax = LDT for current VM
	jcxz	short gthnd9			;Default machine
	sgdt	fword ptr gdt
	mov	edi,dword ptr gdt+2		;*(edi+eax) = attribute of
	mov	eax,5				; 1st descriptor
gthnd7:	add	ax,8				;*di = next descriptor attr
	cmp	byte ptr es:[edi+eax],82h	;LDT?
	jz	short gthnd8			;Yes
	cmp	ax,gdt				;Still within segment limit?
	jc	gthnd7				;Yes, look further
	xor	eax,eax				;Shouldn't happen
gthnd8:	loop	gthnd7				;Get VMth LDT selector
	and	al,not 7			;Kill the 5 offset
gthnd9:	mov	[ebp.Client_AX],ax		;Return:  ax = LDT
	mov	ecx,[ebx.CB_VMID]
	mov	esi,[ebx.CB_High_Linear]	;Return: ebx = VM handle
	ror	esi,10h				;Return si = high-linear
	mov	[ebp.Client_ESI],esi		; high word
	ror	esi,10h				;Restore esi for Trace_Out
	mov	[ebp.Client_EBX],ebx
	Trace_Out "VM #CL Handle=#EBX, LDT=#AX, HighAddr=#ESI"
	pop	ebx
	ret
VxD_CODE_ENDS

VxD_LOCKED_CODE_SEG				;Page Locked Code
BeginProc VSSTD_Control
	clc					;Nothin much goin on here
	ret
EndProc VSSTD_Control
VxD_LOCKED_CODE_ENDS

VxD_REAL_INIT_SEG				;Real-mode initialization
	mov	ah, 9				;Say hi, just for kicks
	mov	dx, offset signon		; (also as warning that
	int	21h				; something's added...)
	xor	bx, bx				;No exclusion table
	xor	si, si				;No instance data table
	xor	edx, edx			;No reference data
	mov	ax, Device_Load_Ok		;Let 'er rip
	ret
signon	db	"SSTP.386 - by MS3",0dh,0ah,'$'
VxD_REAL_INIT_ENDS

	end
